import { NotionPropertyType } from './type-hacks.js';
declare class Descriptor<T extends NotionPropertyType = NotionPropertyType> {
    readonly key: string;
    readonly type: T;
    constructor(key: string, type: T);
    static create<T extends NotionPropertyType>(key: string, type: T): Descriptor<T>;
}
export declare type Schema<K extends string = string, T extends NotionPropertyType = NotionPropertyType> = Record<K, Descriptor<T>>;
export declare class SchemaBuilder<S extends Schema> {
    private schema;
    private constructor();
    static create(): SchemaBuilder<{}>;
    addProperty<T extends NotionPropertyType, K extends string>(key: K, columnName: string, type: T): SchemaBuilder<S & Schema<K, T>>;
    build(): S;
}
export {};
