class Descriptor {
    constructor(key, type) {
        this.key = key;
        this.type = type;
    }
    static create(key, type) {
        return new Descriptor(key, type);
    }
}
export class SchemaBuilder {
    constructor(schema) {
        this.schema = schema;
    }
    static create() {
        return new SchemaBuilder({});
    }
    addProperty(key, columnName, type) {
        const descriptor = Descriptor.create(columnName, type);
        const next = Object.assign(Object.assign({}, this.schema), { [key]: descriptor });
        return new SchemaBuilder(next);
    }
    build() {
        return this.schema;
    }
}
//# sourceMappingURL=schema.js.map